<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import type { Member } from '@/types/Member'
import type { User } from '@/types/User'
import { inject, ref, computed, onMounted, type Ref } from 'vue'

const drawer = inject<Ref<boolean>>('drawer')
const rail = inject<Ref<boolean>>('rail')
const userStore = useAuthStore()

onMounted(() => {
  userStore.getCurrentUser()
})

const isUser = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some(
      (role) => role.name === 'Manager' || role.name === 'Owner' || role.name === 'Employee'
    )
  } else {
    return false
  }
})

// const isMember = computed(() => {
//   const currentMember: Member | null = userStore.getCurrentMember()
//   console.log(currentMember);
//   if (currentMember !== null && currentMember !== undefined) {
//     return true
//   }
//   return false
// })

const isAdmin = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Manager' || role.name === 'Owner')
  }
  return false
})
</script>

<template>
  <div>
    <v-navigation-drawer
      v-model="drawer"
      :rail="rail"
      permanent
      color="brown darken-3"
      @click="rail = false"
    >
      <v-divider></v-divider>
      <div v-if="isUser">
        <v-list density="compact" nav>
          <v-list-item
            prepend-icon="mdi-home-variant"
            title="Home"
            value="home"
            :to="{ name: 'home' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-cash-register"
            title="Point of Sell"
            value="about"
            :to="{ name: 'pos' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-receipt-clock-outline"
            title="Receipt History"
            value="receiptHistory"
            :to="{ name: 'receiptHistory' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-food"
            title="Product"
            value="product"
            :to="{ name: 'pro' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-account-star"
            title="Member"
            value="member"
            :to="{ name: 'mem' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-sale"
            title="Promotion"
            value="promotion"
            :to="{ name: 'promo' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-package-check"
            title="Stock"
            value="stock"
            :to="{ name: 'stock' }"
          ></v-list-item>
          <v-list-group>
            <template v-slot:activator="{ props }">
              <v-list-item
                v-bind="props"
                prepend-icon="mdi-account-group"
                title="Employee"
              ></v-list-item>
            </template>
            <v-list-item
              prepend-icon="mdi-account-group"
              title="Employee"
              value="employee"
              :to="{ name: 'employee' }"
            ></v-list-item>

            <v-list-item
              prepend-icon="mdi-clock-time-nine"
              title="Working Hours"
              value="check"
              :to="{ name: 'check' }"
            ></v-list-item>

            <v-list-item
              prepend-icon="mdi-cash-fast"
              title="Salary"
              value="salary"
              :to="{ name: 'salary' }"
            ></v-list-item>
          </v-list-group>
          <v-list-item
            v-if="isAdmin"
            prepend-icon="mdi-home-group"
            title="Branch"
            value="branch"
            :to="{ name: 'branch' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-invoice-list-outline"
            title="Expense"
            value="expense"
            :to="{ name: 'expense' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-finance"
            title="Sales"
            value="sales"
            :to="{ name: 'sales' }"
          ></v-list-item>
        </v-list>
      </div>

      <div v-if="isUser != true">
        <v-divider></v-divider>
        <v-list density="compact" nav>
          <v-list-item
            prepend-icon="mdi-home-variant"
            title="Home"
            value="home"
            :to="{ name: 'home' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-cash-register"
            title="Point of Sell"
            value="memberspos"
            :to="{ name: 'memberspos' }"
          ></v-list-item>
          <v-list-item
            prepend-icon="mdi-receipt-clock-outline"
            title="Receipt History"
            value="membsesreceiptshistory"
            :to="{ name: 'membsesreceiptshistory' }"
          ></v-list-item>
        </v-list>
      </div>
      <template v-slot:append>
        <v-list-item
          prepend-icon="mdi-logout"
          title="Logout"
          value="logout"
          @click="userStore.logout()"
          density="compact"
          nav
          class="mb-2"
        ></v-list-item>
      </template>
    </v-navigation-drawer>
  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}
</style>
